# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Params-Classify
Version:	0.015
Release:	18.%{__distinit}%{__distvers}
Summary:	Argument type classification
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Params-Classify
Source0:	https://cpan.metacpan.org/modules/by-module/Params/Params-Classify-%{version}.tar.gz
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::CBuilder) >= 0.15
BuildRequires:	perl(ExtUtils::ParseXS) >= 3.30
BuildRequires:	perl(Module::Build)
# Module Runtime
BuildRequires:	perl(Devel::CallChecker) >= 0.003
BuildRequires:	perl(Exporter)
BuildRequires:	perl(parent)
BuildRequires:	perl(Scalar::Util) >= 1.01
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test Suite
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(Test::Pod::Coverage)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Devel::CallChecker) >= 0.003
Requires:	perl(Exporter)
Requires:	perl(Scalar::Util) >= 1.01
Requires:	perl(XSLoader)

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
This module provides various type-testing functions. These are intended
for functions that, unlike most Perl code, care what type of data they
are operating on. For example, some functions wish to behave
differently depending on the type of their arguments (like overloaded
functions in C++).

%prep
%setup -q -n Params-Classify-%{version}

%build
perl Build.PL --installdirs=vendor --optimize="%{optflags}"
./Build

%install
./Build install --destdir=%{buildroot} --create_packlist=0
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
./Build test

%files
%doc Changes README
%{perl_vendorarch}/auto/Params/
%{perl_vendorarch}/Params/
%{_mandir}/man3/Params::Classify.3*

%changelog
* Tue Apr 11 2023 Paul Howarth <paul@city-fan.org> - 0.015-18
- Use SPDX-format license tag

* Thu Jun  2 2022 Paul Howarth <paul@city-fan.org> - 0.015-16
- Perl 5.36 rebuild

* Mon May 24 2021 Paul Howarth <paul@city-fan.org> - 0.015-13
- Perl 5.34 rebuild

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 0.015-10
- Perl 5.32 rebuild

* Thu Jun  6 2019 Paul Howarth <paul@city-fan.org> - 0.015-7
- Perl 5.30 rebuild

* Thu Jun 28 2018 Paul Howarth <paul@city-fan.org> - 0.015-4
- Perl 5.28 rebuild

* Fri Mar  2 2018 Paul Howarth <paul@city-fan.org> - 0.015-2
- Arch-specific package using Module::Build needs to use ExtUtils::CBuilder
  (https://bugzilla.redhat.com/show_bug.cgi?id=1547165#c7)

* Wed Aug  2 2017 Paul Howarth <paul@city-fan.org> - 0.015-1
- Update to 0.015
  - Update for changed S_croak_xs_usage() prototype in ExtUtils::ParseXS 3.30,
    requiring the new version of that module in order to build the XS
    implementation
  - In documentation, use four-column indentation for all verbatim material
  - In META.{yml,json}, point to public bug tracker
  - Correctly classify ExtUtils::ParseXS dependency as a recommendation rather
    than a requirement
  - Avoid some compiler warnings

* Mon Jul 17 2017 Paul Howarth <paul@city-fan.org> - 0.014-1
- Update to 0.014
  - Port to Perl 5.19.4, where the C type of array indices has changed
  - Update to accommodate PERL_OP_PARENT builds of Perl 5.21.11 or later
    (which is the default from Perl 5.25.1)
  - Trigger custom op generation via Devel::CallChecker rather than by hooking
    the underlying op checker
  - Update test suite not to rely on . in @INC, which is no longer necessarily
    there from Perl 5.25.7
  - No longer include a Makefile.PL in the distribution
  - Correct dynamic_config setting to 0
  - Use boolSV() where appropriate in XS code
  - Use cBOOL() where appropriate
  - Consistently use THX_ prefix on internal function names
  - Include META.json in distribution
  - Add MYMETA.json to .cvsignore
  - Convert .cvsignore to .gitignore
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Wed Jun 14 2017 Paul Howarth <paul@city-fan.org> - 0.013-19
- Perl 5.26 rebuild

* Mon May 22 2017 Paul Howarth <paul@city-fan.org> - 0.013-18
- Restore compatibility with Perl 5.26.0 (CPAN RT#114490)
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - BR: perl-devel unconditionally
  - Drop hack for current ExtUtils::ParseXS on old perls

* Wed May 18 2016 Paul Howarth <paul@city-fan.org> - 0.013-16
- Classify buildreqs by usage
- Simplify find command using -empty and -delete
- Add patch to remove hack that breaks builds with current ExtUtils::ParseXS
  versions on old perls

* Sun Aug 31 2014 Paul Howarth <paul@city-fan.org> - 0.013-12
- Drop %%defattr, redundant since rpm 4.4

* Sun Jul 21 2013 Paul Howarth <paul@city-fan.org> - 0.013-8
- Perl 5.18 rebuild

* Fri Jun 29 2012 Paul Howarth <paul@city-fan.org> - 0.013-5
- BR:/R: perl(XSLoader)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3
  - Don't need to define %%{perl_vendorarch}
  - Don't need to run test suite with LC_ALL=C
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Wed Oct  5 2011 Paul Howarth <paul@city-fan.org> - 0.013-4
- Import from Fedora

* Mon Jun 20 2011 Marcela Mašláňová <mmaslano@redhat.com> - 0.013-3
- Perl mass rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.013-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Nov 19 2010 Iain Arnell <iarnell@gmail.com> - 0.013-1
- Update to latest upstream version

* Tue Nov 09 2010 Iain Arnell <iarnell@gmail.com> - 0.012-3
- BR: perl(ExtUtils::ParseXS) ≥ 2.2006 now that it's available

* Sat Nov 06 2010 Iain Arnell <iarnell@gmail.com> - 0.012-2
- Clarify ExtUtils::ParseXS build requirement version

* Thu Nov 04 2010 Iain Arnell <iarnell@gmail.com> - 0.012-1
- Update to latest upstream version
- Use correct optflags macro

* Sun Sep 26 2010 Iain Arnell <iarnell@gmail.com> - 0.011-1
- Specfile autogenerated by cpanspec 1.78
